#include <stdio.h>
#include "RamMemory.hh"

void RamMemory::Load(RegType p, MemoryUser *mu, int tag)
{
  int i = int(p % 0xFFFFFFFF);
  if((p>>(sizeof(RegType)-sizeof(void*)))!=0)
     printf("Warning High part of pointer non-nil\n");
  if((i/sizeof(RegType))>size)
    printf("Error Memory Reference out of bounds\n");
  mu->get(memory[i/sizeof(RegType)], tag);
}

void RamMemory::Store(RegType p, RegType d, int size)
{
 int i = int(p % 0xFFFFFFFF);
  if((p>>(sizeof(RegType)-sizeof(void*)))!=0)
     printf("Warning High part of pointer non-nil\n");
  if((i/sizeof(RegType))>size)
    printf("Error Memory Reference out of bounds\n");
  
  switch(size)
    {
    case 64: memory[i/sizeof(RegType)] = d;
      break;
    case 32: memory[i/sizeof(RegType)] = int(d % 0xFFFFFFFF);
      break;
    case 16: memory[i/sizeof(RegType)] = short(d % 0xFFFF);
      break;
    case 8: memory[i/sizeof(RegType)] = char(d % 0xFFFF);
      break;
    default: printf("Error in Memory Size: %d", size);
    }
}

void RamMemory::LoadBlock(RegType p, MemoryUser *mu, int tag, int size, int count){}
void RamMemory::StoreBlock(RegType p, RegType *d, int size, int count){}

int RamMemory::getInstruction(RegType p)
{
 int i = int(p % 0xFFFFFFFF);
 if((p>>(sizeof(RegType)-sizeof(void*)))!=0)
   printf("Warning High part of pointer non-nil\n");
 if(i>size) 
   printf("Error Memory Reference out of bounds\n");
 return int(((int *)memory)[i/sizeof(int)]);  
}
